/*
 * Copyright (C) 2015 Infineon Technologies AG. All rights reserved.
 *
 * Infineon Technologies AG (Infineon) is supplying this software for use with
 * Infineon's microcontrollers.
 * This file can be freely distributed within development tools that are
 * supporting such microcontrollers.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 *
 * INFINEON SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,OR CONSEQUENTIAL DAMAGES, FOR ANY REASON
 * WHATSOEVER.
 */
/*
 * XMC45_IRQ.h
 *
 *  Created on: 13 May, 2015
 *      Author: toochang
 */

#ifndef XMC45_IRQ_H_
#define XMC45_IRQ_H_

/*********************************************************************************************************************
 * IRQ Priority list 0 = highest and 63 = lowest
 *
 *		IRQ								Priority		Interrupt type
 *********************************************************************************************************************/
#define VADC0_G0_0_IRQn_0					0			// Source interrupt
#define VADC0_G0_1_IRQn_1					1			// Channel interrupt
#define VADC0_G0_2_IRQn_2					2			// Result interrupt
#define dummy_3								3
#define dummy_4								4
#define dummy_5								5
#define CCU80_2_IRQn_6						6
#define CCU40_3_IRQn_7						7
#define dummy_8								8
#define dummy_9								9

#define GPDMA0_0_IRQn_10					10
#define dummy_11							11
#define dummy_12							12
#define dummy_13							13
#define dummy_14							14
#define dummy_15							15
#define SCU_0_IRQn_16						16			// WDT pre warn interrupt
#define FCE0_0_IRQn_17						17
#define dummy_18							18
#define dummy_19							19

#define CAN0_7_IRQn_20						20
#define USIC0_0_IRQn_21						21
#define USIC0_1_IRQn_22						22
#define dummy_23							23
#define dummy_24							24
#define dummy_25							25
#define dummy_26							26
#define dummy_27							27
#define dummy_28							28
#define dummy_29							29

#define dummy_30							30
#define dummy_31							31
#define dummy_32							32
#define dummy_33							33
#define dummy_34							34
#define dummy_35							35
#define dummy_36							36
#define dummy_37							37
#define dummy_38							38
#define dummy_39							39


/*********************************************************************************************************************
 * Rename of Interrupt handler
 *********************************************************************************************************************/
#define SCU_ISR    							SCU_0_IRQHandler
#define IRQ_Hdlr_Rename_1   				ERU0_0_IRQHandler
#define IRQ_Hdlr_Rename_2   				ERU0_1_IRQHandler
#define IRQ_Hdlr_Rename_3   				ERU0_2_IRQHandler
#define IRQ_Hdlr_Rename_4   				ERU0_3_IRQHandler
#define IRQ_Hdlr_Rename_5   				ERU1_0_IRQHandler
#define IRQ_Hdlr_Rename_6   				ERU1_1_IRQHandler
#define IRQ_Hdlr_Rename_7   				ERU1_2_IRQHandler
#define IRQ_Hdlr_Rename_8   				ERU1_3_IRQHandler
#define IRQ_Hdlr_Rename_12  				PMU0_0_IRQHandler
#define IRQ_Hdlr_Rename_14  				VADC0_C0_0_IRQHandler
#define IRQ_Hdlr_Rename_15  				VADC0_C0_1_IRQHandler
#define IRQ_Hdlr_Rename_16  				VADC0_C0_2_IRQHandler
#define IRQ_Hdlr_Rename_17  				VADC0_C0_3_IRQHandler
#define VADC_Source_ISR  					VADC0_G0_0_IRQHandler
#define VADC_Channel_ISR	  				VADC0_G0_1_IRQHandler
#define VADC_Result_ISR						VADC0_G0_2_IRQHandler
#define IRQ_Hdlr_Rename_21  				VADC0_G0_3_IRQHandler
#define IRQ_Hdlr_Rename_22  				VADC0_G1_0_IRQHandler
#define IRQ_Hdlr_Rename_23  				VADC0_G1_1_IRQHandler
#define IRQ_Hdlr_Rename_24 					VADC0_G1_2_IRQHandler
#define IRQ_Hdlr_Rename_25  				VADC0_G1_3_IRQHandler
#define IRQ_Hdlr_Rename_26  				VADC0_G2_0_IRQHandler
#define IRQ_Hdlr_Rename_27  				VADC0_G2_1_IRQHandler
#define IRQ_Hdlr_Rename_28  				VADC0_G2_2_IRQHandler
#define IRQ_Hdlr_Rename_29  				VADC0_G2_3_IRQHandler
#define IRQ_Hdlr_Rename_30  				VADC0_G3_0_IRQHandler
#define IRQ_Hdlr_Rename_31  				VADC0_G3_1_IRQHandler
#define IRQ_Hdlr_Rename_32  				VADC0_G3_2_IRQHandler
#define IRQ_Hdlr_Rename_33 					VADC0_G3_3_IRQHandler
#define IRQ_Hdlr_Rename_34  				DSD0_0_IRQHandler
#define IRQ_Hdlr_Rename_35  				DSD0_1_IRQHandler
#define IRQ_Hdlr_Rename_36  				DSD0_2_IRQHandler
#define IRQ_Hdlr_Rename_37  				DSD0_3_IRQHandler
#define IRQ_Hdlr_Rename_38  				DSD0_4_IRQHandler
#define IRQ_Hdlr_Rename_39  				DSD0_5_IRQHandler
#define IRQ_Hdlr_Rename_40  				DSD0_6_IRQHandler
#define IRQ_Hdlr_Rename_41 					DSD0_7_IRQHandler
#define IRQ_Hdlr_Rename_42  				DAC0_0_IRQHandler
#define IRQ_Hdlr_Rename_43  				DAC0_1_IRQHandler
#define IRQ_Hdlr_Rename_44  				CCU40_0_IRQHandler
#define IRQ_Hdlr_Rename_45  				CCU40_1_IRQHandler
#define IRQ_Hdlr_Rename_46  				CCU40_2_IRQHandler
#define Input_Capture_ISR	  				CCU40_3_IRQHandler
#define IRQ_Hdlr_Rename_48  				CCU41_0_IRQHandler
#define IRQ_Hdlr_Rename_49  				CCU41_1_IRQHandler
#define IRQ_Hdlr_Rename_50  				CCU41_2_IRQHandler
#define IRQ_Hdlr_Rename_51  				CCU41_3_IRQHandler
#define IRQ_Hdlr_Rename_52  				CCU42_0_IRQHandler
#define IRQ_Hdlr_Rename_53  				CCU42_1_IRQHandler
#define IRQ_Hdlr_Rename_54  				CCU42_2_IRQHandler
#define IRQ_Hdlr_Rename_55  				CCU42_3_IRQHandler
#define IRQ_Hdlr_Rename_56  				CCU43_0_IRQHandler
#define IRQ_Hdlr_Rename_57  				CCU43_1_IRQHandler
#define IRQ_Hdlr_Rename_58  				CCU43_2_IRQHandler
#define IRQ_Hdlr_Rename_59  				CCU43_3_IRQHandler
#define IRQ_Hdlr_Rename_60  				CCU80_0_IRQHandler
#define IRQ_Hdlr_Rename_61  				CCU80_1_IRQHandler
#define PWM_PeriodMatch_ISR  				CCU80_2_IRQHandler
#define IRQ_Hdlr_Rename_63  				CCU80_3_IRQHandler
#define IRQ_Hdlr_Rename_64  				CCU81_0_IRQHandler
#define IRQ_Hdlr_Rename_65  				CCU81_1_IRQHandler
#define IRQ_Hdlr_Rename_66  				CCU81_2_IRQHandler
#define IRQ_Hdlr_Rename_67  				CCU81_3_IRQHandler
#define IRQ_Hdlr_Rename_68  				POSIF0_0_IRQHandler
#define IRQ_Hdlr_Rename_69  				POSIF0_1_IRQHandler
#define IRQ_Hdlr_Rename_70  				POSIF1_0_IRQHandler
#define IRQ_Hdlr_Rename_71  				POSIF1_1_IRQHandler
#define IRQ_Hdlr_Rename_76  				CAN0_0_IRQHandler
#define IRQ_Hdlr_Rename_77  				CAN0_1_IRQHandler
#define IRQ_Hdlr_Rename_78  				CAN0_2_IRQHandler
#define IRQ_Hdlr_Rename_79  				CAN0_3_IRQHandler
#define IRQ_Hdlr_Rename_80  				CAN0_4_IRQHandler
#define IRQ_Hdlr_Rename_81  				CAN0_5_IRQHandler
#define IRQ_Hdlr_Rename_82  				CAN0_6_IRQHandler
#define CAN_Rx_ISR			  				CAN0_7_IRQHandler
#define UART_Tx_ISR							USIC0_0_IRQHandler
#define UART_Rx_ISR		    				USIC0_1_IRQHandler
#define IRQ_Hdlr_Rename_86  				USIC0_2_IRQHandler
#define IRQ_Hdlr_Rename_87  				USIC0_3_IRQHandler
#define IRQ_Hdlr_Rename_88  				USIC0_4_IRQHandler
#define IRQ_Hdlr_Rename_89  				USIC0_5_IRQHandler
#define IRQ_Hdlr_Rename_90  				USIC1_0_IRQHandler
#define IRQ_Hdlr_Rename_91  				USIC1_1_IRQHandler
#define IRQ_Hdlr_Rename_92  				USIC1_2_IRQHandler
#define IRQ_Hdlr_Rename_93  				USIC1_3_IRQHandler
#define IRQ_Hdlr_Rename_94  				USIC1_4_IRQHandler
#define IRQ_Hdlr_Rename_95  				USIC1_5_IRQHandler
#define IRQ_Hdlr_Rename_96  				USIC2_0_IRQHandler
#define IRQ_Hdlr_Rename_97  				USIC2_1_IRQHandler
#define IRQ_Hdlr_Rename_98  				USIC2_2_IRQHandler
#define IRQ_Hdlr_Rename_99  				USIC2_3_IRQHandler
#define IRQ_Hdlr_Rename_100 				USIC2_4_IRQHandler
#define IRQ_Hdlr_Rename_101 				USIC2_5_IRQHandler
#define IRQ_Hdlr_Rename_102 				LEDTS0_0_IRQHandler
#define FCE_Error_ISR 						FCE0_0_IRQHandler
#define IRQ_Hdlr_Rename_105 				GPDMA0_0_IRQHandler
#define IRQ_Hdlr_Rename_106 				SDMMC0_0_IRQHandler
#define IRQ_Hdlr_Rename_107 				USB0_0_IRQHandler
#define IRQ_Hdlr_Rename_108 				ETH0_0_IRQHandler
#define IRQ_Hdlr_Rename_110 				GPDMA1_0_IRQHandler


#endif /* XMC45_IRQ_H_ */
