/*
 * flash_loader.c
 *
 *  Created on: 1 Apr, 2016
 *      Author: toochang
 */

#include "XMC45_INIT.h"


typedef struct File_TAG
{
	uint32_t Size;
	uint32_t balance_Page;
	uint32_t balance_Bytes;
}File_T;
File_T binFile;

// For reading of bin file
uint8_t buff[PAGE_256];
FATFS fs;      		/* File system object (volume work area) */
FIL file;       	/* File object */
FRESULT res;   		/* API result code */
uint32_t bw,br;     /* bw = number of bytes write, br = number of bytes read*/




FL_STATUS_t Flash_loader (void)
{
	uint32_t i;

	FL_STATUS_t fl_status;

	fl_status = FL_SUCCESS;

    /* Register work area  */
     res = f_mount(&fs, "0:", 1);
     res = f_open(&file, "firmware.bin", FA_READ);

     if ((res == FR_OK) || (res == FR_EXIST))
     {
    	 // Here we have found an existing file
    	 XMC_GPIO_SetOutputHigh(LED2_PROG); 	// ON LED

  	 	 Flash_Init();

    	 /**************************************************
    	  * Base on the file size we calculate the number of
    	  * page and balance bytes
    	  **************************************************/
  	 	binFile.Size = file.fsize;

 		// Break up the files into block size of 1K and balance
  	 	binFile.balance_Page = binFile.Size / PAGE_256;
  	 	binFile.balance_Bytes = binFile.Size % PAGE_256;


  	 	/***************************************************
  	 	 * Here we can start the flash programming
  	 	 ***************************************************/
  	 	for(;binFile.balance_Page>0; binFile.balance_Page--)
  	 	{
  	 		res = f_read(&file, buff, sizeof buff, &br);  /* Read a chunk of source file */
  	 		FLASH_WritePage();
  	 	}

  	 	for(i=0; i<PAGE_256; i++)
  	 		buff[i] = 0;

	 	res = f_read(&file, buff, binFile.balance_Bytes, &br);  /* Read a chunk of source file */
	 	FLASH_WritePage();


	 	if(file.fptr != file.fsize)
	 	{
	 		fl_status = FL_FLASH_ERR;
	 	}

     }

     else
     {
    	 fl_status = FL_SD_ERR;
     }

	 return(fl_status);
}


